System.Gadget.onSettingsClosing = SettingsClosing;
var fso = new ActiveXObject("Scripting.FileSystemObject");
var s = fso.OpenTextFile(System.Gadget.path + "\\settings.txt" , 1, false);
var linkName = s.readline();
var linkKey = s.readline();
var linkUrl = s.readline();
s.Close();

function populateItems() {
	var v = document.getElementById("currLinks");
	v.innerHTML = "";
	if (1) {
		var tbl     = document.createElement("table");
		var tblBody = document.createElement("tbody");
		var row = document.createElement("tr");
		var cell1 = document.createElement("td");
		var cell2 = document.createElement("td");
		var cell3 = document.createElement("td");
		cell2.setAttribute("align", "right");
		cell1.className="linkLine";
		cell2.className="linkLine";
		cell3.className="linkLine";
		cell1.appendChild(document.createTextNode("Key"));
		cell2.appendChild(document.createTextNode("Name"));
		row.appendChild(cell3);
		row.appendChild(cell2);
		row.appendChild(cell1);
		tblBody.appendChild(row);

		var linksNames = linkName.split("|");
		var linksKeys = linkKey.split("|");
		for (var i = 0 ; i < linksNames.length ; i++) {
			var row = document.createElement("tr");
			var cell1 = document.createElement("td");
			var cell2 = document.createElement("td");
			var cell3 = document.createElement("td");
			cell2.setAttribute("align", "right");
			cell1.className="linkLine";
			cell2.className="linkLine";
			cell3.className="linkLine";
			cell1.appendChild(document.createTextNode(linksKeys[i]));
			var e = document.createElement("a");
			var img = document.createElement("img");
			img.setAttribute("src", "delete.png");
			img.setAttribute("border", "0");
			e.appendChild(img);
			e.setAttribute("href", "javascript:deleteItem(" + i + ")");
			cell2.appendChild(e);
			cell2.appendChild(document.createTextNode(linksNames[i]));
			cell3.appendChild(e);
			row.appendChild(cell3);
			row.appendChild(cell2);
			row.appendChild(cell1);
			tblBody.appendChild(row);
		}
		tbl.appendChild(tblBody);
		v.appendChild(tbl);
	}
}


function SettingsClosing(event) {
	if (event.closeAction == event.Action.commit) {
		var s = fso.OpenTextFile(System.Gadget.path + "\\settings.txt" , 2, true);
		s.writeline(linkName);
		s.writeline(linkKey);
		s.writeline(linkUrl);
		s.Close();

	}
	fso = s = null;
	event.cancel = false;
}


function addItem() {
	//	    System.Sound.beep();
	var txt = document.getElementById("newLinkName");
	var key = document.getElementById("newLinkKey");
	var url = document.getElementById("newLinkUrl");
	if (txt.value != "" && key.value != "" && url.value != "") {
		if(linkName != "") {
			linkName += "|";
			linkKey += "|";
			linkUrl += "|";
		}
		linkName += txt.value;
		linkKey += key.value;
		linkUrl += url.value;
		populateItems();
	}
	txt.value = "";
	key.value = "";
	url.value = "";
	txt.focus();
}


function deleteItem(index) {
	var str = "";
	var str2 = "";
	var str3 = "";
	linksNames = linkName.split("|");
	linksKeys = linkKey.split("|");
	linksUrls = linkUrl.split("|");
	for (var i = 0 ; i < linksNames.length ; i++) {
		if (i != index) {
			if (str != "") {
				str += "|";
				str2 += "|";
				str3 += "|";
			}
			str += linksNames[i];
			str2 += linksUrls[i];
			str3 += linksKeys[i];
		}
	}
	linkName = str;
	linkKey = str3;
	linkUrl = str2;
	this.populateItems();
}

function showReadme() {
//	System.Shell.execute(System.Gadget.path + "\\readme.txt");
	var v = document.getElementById("topbox");
	v.innerHTML = "<legend class='legend'><b>Usage</b></legend>" +
	"<div id='currLinks' style='width: 100%; height: 300px; overflow: auto; text-align: left;'>" +
	"<span style='width: 100%; text-align: left; height: 300px;'>" +
	"<br />Type a URL in the box to open a webpage.<br />" +
	"For example: 'http://www.google.com' or 'google.com' will open the Google webpage.<br />" +
	"<br />Type a local path to open a file or directory on your computer.<br /> <br />" +
	"Type a keyword followed by a query to search using the search engine defined by the keyword.<br />" +
	"For example: 'g Sidebar gadgets' will search for 'Sidebar gadgets' using Google. </span></div>";

	var v = document.getElementById("bottombox");
	v.innerHTML = "<input type='button' value='Adding Engines' onclick='addingEngines();' />"; 
}
function addingEngines() {
	var v = document.getElementById("topbox");
	v.innerHTML = "<legend class='legend'><b>Adding Search Engines</b></legend>" +
	"<div id='currLinks' style='width: 100%; height: 300px; overflow: auto; text-align: left;'>" +
	"<span style='width: 100%; text-align: left; height: 300px;'>" +
	"<br />To find the Engine URL, do a search for 'TEST' with the Search Engine you want to add - everything in the URL before 'TEST' is your Engine URL.<br /><br />" +
	"For example: searching for 'TEST' at google.com gives the following URL: <br />" +
	"<b>http://www.google.com/search?q=TEST </b><br />" +
	"so the Engine URL is: <b> http://www.google.com/search?q= </b><br /><br />" + 
        "<br />You need to have administrative rights on your account to add or remove search engines through the Settings interface.<br />" +
	"<br />If you don't, you'll need to manually edit the settings to add or remove search engines. You can do so by clicking the button below.<br />" +
	"</span></div>";
	var v = document.getElementById("bottombox");
	v.innerHTML = "<input type='button' value='Manual Edit' onclick='manualSettings();' />"; 

}
function manualSettings() {
	var v = document.getElementById("topbox");
	v.innerHTML = "<legend class='legend'><b>Manually Editing Search Engines</b></legend>" +
	"<div id='currLinks' style='width: 100%; height: 320px; overflow: auto; text-align: left;'>" +
	"<span style='width: 100%; text-align: left; height: 320px;'>" +
	"<br />I haven't been able to work out how to write to file from within the gadget without administrative rights, " +
	"so if you don't have administrative rights you will need to edit the settings file directly to make changes. <br /><br />" +
	"The settings file should have opened automatically in your default text editor when you clicked the button. If not, it is located at: <br /><br />" +
	"%userprofile%\\AppData\\Local\\Microsoft\\Windows Sidebar\\Gadgets\\Omnibox.gadget\\settings.txt <br /><br />" +
	"The file consists of 3 lines. Line 1 contains the string of Engine Names, line 2 the string of Engine Keywords, and line 3 the string of Engine URLs. <br /><br />" +
	"Each line uses the '|' symbol as a separator between elements. <br /></span></div>";
	var v = document.getElementById("bottombox");
	v.innerHTML = ""; 
	System.Shell.execute(System.Gadget.path + "\\settings.txt");

}